var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import * as sharedPropTypes from '../_prop-types';

import FileUploadCallToAction from './FileUploadCallToAction';
import FileUploadLabel from './FileUploadLabel';
import FileUploadInput from './FileUploadInput';
import FileUploadName from './FileUploadName';

var FileUpload = (_temp2 = _class = function (_React$Component) {
  _inherits(FileUpload, _React$Component);

  function FileUpload() {
    var _temp, _this, _ret;

    _classCallCheck(this, FileUpload);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.render = function () {
      var _classNames;

      var _this$props = _this.props,
          className = _this$props.className,
          children = _this$props.children,
          color = _this$props.color,
          isBoxed = _this$props.isBoxed,
          isFullWidth = _this$props.isFullWidth,
          isRight = _this$props.isRight,
          hasName = _this$props.hasName,
          size = _this$props.size,
          props = _objectWithoutProperties(_this$props, ['className', 'children', 'color', 'isBoxed', 'isFullWidth', 'isRight', 'hasName', 'size']);

      return React.createElement(
        'div',
        _extends({
          className: classNames('file', (_classNames = {}, _classNames[className] = Boolean(className), _classNames['is-' + color] = Boolean(color), _classNames['is-' + size] = Boolean(size), _classNames['is-boxed'] = isBoxed, _classNames['is-fullwidth'] = isFullWidth, _classNames['is-right'] = isRight, _classNames['has-name'] = hasName, _classNames))
        }, props),
        children
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return FileUpload;
}(React.Component), _class.CallToAction = FileUploadCallToAction, _class.Input = FileUploadInput, _class.Label = FileUploadLabel, _class.Name = FileUploadName, _temp2);


FileUpload.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  /**
   * Button color. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger`
   */
  color: sharedPropTypes.color,
  /** Make the call to action a box shape. */
  isBoxed: PropTypes.bool,
  /** Expand the file upload to fill up the space. */
  isFullWidth: PropTypes.bool,
  /** Align the <FileUpload.CallToAction> component to the right */
  isRight: PropTypes.bool,
  /** Set to `true` if a <FileUpload.Name> exists */
  hasName: PropTypes.bool,
  /** Size of the file upload field. Available values: `small`, `medium`, `large` */
  size: sharedPropTypes.size
} : {};

FileUpload.defaultProps = {
  className: null,
  color: null,
  isBoxed: false,
  isFullWidth: false,
  isRight: false,
  hasName: false,
  size: null
};

export default FileUpload;