var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var Tile = function Tile(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      context = _ref.context,
      Element = _ref.element,
      isVertical = _ref.isVertical,
      size = _ref.size,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'context', 'element', 'isVertical', 'size']);

  return React.createElement(
    Element,
    _extends({
      className: classNames('tile', (_classNames = {}, _classNames[className] = Boolean(className), _classNames['is-' + context] = Boolean(context), _classNames['is-' + size] = Boolean(size), _classNames['is-vertical'] = isVertical, _classNames))
    }, props),
    children
  );
};

Tile.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node,
  className: PropTypes.string,
  /** Contextual modifier. Available values: `ancestor`, `parent`, `child` */
  context: PropTypes.oneOf(['ancestor', 'parent', 'child']),
  element: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  /** Is the tile vertical? */
  isVertical: PropTypes.bool,
  /** Size of the tile. Available values: `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`, `10`, `11`, `12` */
  size: PropTypes.oneOf(['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12'])
} : {};

Tile.defaultProps = {
  children: null,
  className: null,
  context: null,
  element: 'div',
  isVertical: false,
  size: null
};

export default Tile;