'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

var _FileUploadCallToAction = require('./FileUploadCallToAction');

var _FileUploadCallToAction2 = _interopRequireDefault(_FileUploadCallToAction);

var _FileUploadLabel = require('./FileUploadLabel');

var _FileUploadLabel2 = _interopRequireDefault(_FileUploadLabel);

var _FileUploadInput = require('./FileUploadInput');

var _FileUploadInput2 = _interopRequireDefault(_FileUploadInput);

var _FileUploadName = require('./FileUploadName');

var _FileUploadName2 = _interopRequireDefault(_FileUploadName);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FileUpload = (_temp2 = _class = function (_React$Component) {
  _inherits(FileUpload, _React$Component);

  function FileUpload() {
    var _temp, _this, _ret;

    _classCallCheck(this, FileUpload);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.render = function () {
      var _classNames;

      var _this$props = _this.props,
          className = _this$props.className,
          children = _this$props.children,
          color = _this$props.color,
          isBoxed = _this$props.isBoxed,
          isFullWidth = _this$props.isFullWidth,
          isRight = _this$props.isRight,
          hasName = _this$props.hasName,
          size = _this$props.size,
          props = _objectWithoutProperties(_this$props, ['className', 'children', 'color', 'isBoxed', 'isFullWidth', 'isRight', 'hasName', 'size']);

      return _react2.default.createElement(
        'div',
        _extends({
          className: (0, _classnames2.default)('file', (_classNames = {}, _classNames[className] = Boolean(className), _classNames['is-' + color] = Boolean(color), _classNames['is-' + size] = Boolean(size), _classNames['is-boxed'] = isBoxed, _classNames['is-fullwidth'] = isFullWidth, _classNames['is-right'] = isRight, _classNames['has-name'] = hasName, _classNames))
        }, props),
        children
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return FileUpload;
}(_react2.default.Component), _class.CallToAction = _FileUploadCallToAction2.default, _class.Input = _FileUploadInput2.default, _class.Label = _FileUploadLabel2.default, _class.Name = _FileUploadName2.default, _temp2);


FileUpload.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  /**
   * Button color. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger`
   */
  color: sharedPropTypes.color,
  /** Make the call to action a box shape. */
  isBoxed: _propTypes2.default.bool,
  /** Expand the file upload to fill up the space. */
  isFullWidth: _propTypes2.default.bool,
  /** Align the <FileUpload.CallToAction> component to the right */
  isRight: _propTypes2.default.bool,
  /** Set to `true` if a <FileUpload.Name> exists */
  hasName: _propTypes2.default.bool,
  /** Size of the file upload field. Available values: `small`, `medium`, `large` */
  size: sharedPropTypes.size
} : {};

FileUpload.defaultProps = {
  className: null,
  color: null,
  isBoxed: false,
  isFullWidth: false,
  isRight: false,
  hasName: false,
  size: null
};

exports.default = FileUpload;
module.exports = exports['default'];