'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Tile = function Tile(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      context = _ref.context,
      Element = _ref.element,
      isVertical = _ref.isVertical,
      size = _ref.size,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'context', 'element', 'isVertical', 'size']);

  return _react2.default.createElement(
    Element,
    _extends({
      className: (0, _classnames2.default)('tile', (_classNames = {}, _classNames[className] = Boolean(className), _classNames['is-' + context] = Boolean(context), _classNames['is-' + size] = Boolean(size), _classNames['is-vertical'] = isVertical, _classNames))
    }, props),
    children
  );
};

Tile.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  /** Contextual modifier. Available values: `ancestor`, `parent`, `child` */
  context: _propTypes2.default.oneOf(['ancestor', 'parent', 'child']),
  element: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  /** Is the tile vertical? */
  isVertical: _propTypes2.default.bool,
  /** Size of the tile. Available values: `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`, `10`, `11`, `12` */
  size: _propTypes2.default.oneOf(['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12'])
} : {};

Tile.defaultProps = {
  children: null,
  className: null,
  context: null,
  element: 'div',
  isVertical: false,
  size: null
};

exports.default = Tile;
module.exports = exports['default'];